Bug 586482 - ATIIXP IDE driver reuses ide_lock unsafely
ATIIXP IDE driver reuses ide_lock unsafely
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.5
i686 Linux
medium Severity high
: rc
: ---
Assigned To: Prarit Bhargava
Gris Ge
: Reopened
: 643141 (view as bug list)
Depends On:
Blocks: 677384
  Show dependency treegraph
 
Reported: 2010-04-27 13:29 EDT by Bryn M. Reeves
Modified: 2011-02-14 10:06 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 216289
Environment:
Last Closed: 2011-01-13 16:29:41 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Fix atiixp locking (2.75 KB, patch)
2010-04-27 13:31 EDT, Bryn M. Reeves
no flags Details | Diff
RHEL5 fix for this issue (2.74 KB, patch)
2010-05-18 11:29 EDT, Prarit Bhargava
no flags Details | Diff

  None (edit)
Description Bryn M. Reeves 2010-04-27 13:29:41 EDT
+++ This bug was initially created as a clone of Bug #216289 +++

+++ This bug was initially created as a clone of Bug #178121 +++
Splitting this as its two bugs

-- Additional comment from bill+redhat@bfccomputing.com on 2006-11-12 19:00 EST --
Some more information; I put in a Zod DVD to do an upgrade and the BIOS wasn't
set to boot from CD.  So when I came back to the computer I had the usual
lockup, but this time a stacktrace as well!  Included for your debugging pleasure:

BUG: spinlock recursion on CPU#0, swapper/0 (Not tainted)
lock: c06e6980, .magic: dead4end, .owner: swapper/0, .owner_cpu: 0
[<c05060ef>] dump_trace+0x69/0x1af
[<c040524d>] show_trace_log_lvl+0x18/0x2c
[<c0506800>] show_trace+0xf/0x11
[<c05068fa>] dump_stack+0x15/0x17
[<c04e82c9>] _raw_spin_lock+0x35/0xdc
[<c060fcd0>] _spin_lock_irqsave+0x9/0xd
[<c055875e>] atiixp_ide_dma_host_off+0x1b/0x7c
[<c056cd5a>] __ide_dma_off_quitely+0x19/0x23
[<c056c628>] __ide_dma_off+0x21/0x25
[<c05674b9>] do_reset1+0x42/0x191
[<c0566979>] __ide_error+0x197/0x1aa
[<c05669e8>] ide_error+0x5c/0x72
[<f8930c9e>] cdrom_decode_status+0x219/0x2a5 [ide_cd]
[<f8931466>] cdrom_read_intr+0x58/0x30e [ide_cd]
[<c0566708>] ide_intr+0x146/0x1a7
[<c044b95a>] handle_IRQ_event+0x23/0x49
[<c044ba16>] __do_IRQ+0x96/0xf2
[<c04067cf>] do_IRQ+0x9e/0xbc

Hopefully I typed all that correctly...

-- Additional comment from bill+redhat@bfccomputing.com on 2006-11-18 03:22 EST --
For grins I replaced the Pioneer writer with an LG writer and the kernel crash
gives the same stack.

Someone with perms can set this for fc6, and clear NEEDINFO unless there's more
to collect.

--- Additional comment from alan@redhat.com on 2007-01-02 10:42:49 EST ---

Upstream patch prepared

--- Additional comment from bill-bugzilla.redhat.com@bfccomputing.com on 2007-01-04 15:33:24 EST ---

URL for Alan's patch:
  http://lkml.org/lkml/diff/2007/1/2/126/1

(I'm not "sufficiently empowered") to modify the URL field.

Thanks, Alan.
Comment 1 Bryn M. Reeves 2010-04-27 13:31:04 EDT
Created attachment 409533 [details]
Fix atiixp locking

Don't abuse ide_lock in atiixp.
Comment 3 Prarit Bhargava 2010-05-18 11:29:55 EDT
Created attachment 414894 [details]
RHEL5 fix for this issue

Updated patch to latest RHEL5.
Comment 10 Prarit Bhargava 2010-09-29 09:04:17 EDT
Based on comment #9, INSUFFICIENT_DATA.

P.
Comment 12 Prarit Bhargava 2010-10-21 09:17:08 EDT
*** Bug 643141 has been marked as a duplicate of this bug. ***
Comment 16 Jarod Wilson 2010-11-09 12:11:57 EST
in kernel-2.6.18-231.el5
You can download this test kernel (or newer) from http://people.redhat.com/jwilson/el5

Detailed testing feedback is always welcomed.
Comment 18 Gris Ge 2010-12-08 02:35:41 EST
Prarit,

Do you know what hardware I need to reproduce this bug?

Thank you.
Comment 19 Prarit Bhargava 2010-12-13 12:36:10 EST
(In reply to comment #18)
> Prarit,
> 
> Do you know what hardware I need to reproduce this bug?
> 
> Thank you.

No HW available unfortunately.  But you can sanity test with any system with a DVD drive in it.

P.
Comment 20 Gris Ge 2010-12-20 02:15:19 EST
No hardware for testing.

Code reviewed. kernel-2.6.18-236.el5 has the patch "linux-2.6-ide-atiixp-fix-locking-hang-in-ide-layer-atiixp-driver.patch" applied.

Set as SanityOnly.
Comment 22 errata-xmlrpc 2011-01-13 16:29:41 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2011-0017.html

Note You need to log in before you can comment on or make changes to this bug.